<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:44 PDT 2008 -->
<TITLE>
Comparators (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.collect.Comparators class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="Comparators (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/Collections2.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/ConcurrentMultiset.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/Comparators.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Comparators.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
com.google.common.collect</FONT>
<BR>
Class Comparators</H2>
<PRE>
<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>com.google.common.collect.Comparators</B>
</PRE>
<HR>
<DL>
<DT><PRE>public final class <B>Comparators</B><DT>extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
Standard comparators and utilities for creating and working with comparators.

 <p>Some of these methods return an <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A>, a serializable class
 that implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util"><CODE>Comparator</CODE></A> and includes many additional methods.

 <p>Several method signatures include <code>&lt;C extends Comparable&gt;</code> with a
 raw <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang"><CODE>Comparable</CODE></A>, instead of
 <code>&lt;C extends Comparable&lt;? super C&gt;</code>. That's necessary to support classes
 defined without generics.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Jared Levy, Kevin Bourrillion, Mike Bostock</DD>
</DL>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;<A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#STRING_FORM_ORDER">STRING_FORM_ORDER</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;A comparator that compares objects by the natural ordering of their string
 representations as returned by <code>toString()</code>.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(boolean, boolean)">compare</A></B>(boolean&nbsp;a,
        boolean&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>boolean</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(byte, byte)">compare</A></B>(byte&nbsp;a,
        byte&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>byte</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(char, char)">compare</A></B>(char&nbsp;a,
        char&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>char</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(double, double)">compare</A></B>(double&nbsp;a,
        double&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>double</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(float, float)">compare</A></B>(float&nbsp;a,
        float&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>float</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(int, int)">compare</A></B>(int&nbsp;a,
        int&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>int</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(long, long)">compare</A></B>(long&nbsp;a,
        long&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>long</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compare(short, short)">compare</A></B>(short&nbsp;a,
        short&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Compares the two specified <code>short</code> values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.util.Comparator, java.util.Comparator)">compound</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator which tries two comparators in order until a non-zero
 result is found, returning that result, and returning zero only if both
 comparators return zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.util.Comparator, java.util.Comparator, java.util.Comparator)">compound</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator which tries three comparators in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator)">compound</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;forth)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator which tries four comparators in order until a non-zero
 result is found, returning that result, and returning zero only if all
 comparators return zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator...)">compound</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;forth,
         <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;...&nbsp;rest)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator which tries each given comparator in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.lang.Iterable)">compound</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&gt;&nbsp;comparators)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator which tries each given comparator in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;F,T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
<A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;F&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#fromFunction(com.google.common.base.Function)">fromFunction</A></B>(<A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;F,T&gt;&nbsp;function)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a comparator that compares any two items by applying a function to
 each of them and using the natural ordering of the results.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;F,T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;F&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#fromFunction(com.google.common.base.Function, java.util.Comparator)">fromFunction</A></B>(<A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;F,T&gt;&nbsp;function,
             <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a comparator that compares any two items by applying a function to
 each of them and using the supplied comparator to compare the results.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#givenOrder(java.util.List)">givenOrder</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;? extends T&gt;&nbsp;valuesInOrder)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that compares objects according to the order in
 which they appear in the given list.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#givenOrder(T, T...)">givenOrder</A></B>(T&nbsp;leastValue,
           T...&nbsp;remainingValuesInOrder)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the comparator that compares objects according to the order in
 which they are given to this method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#max(java.util.Comparator, T, T)">max</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator,
    T&nbsp;a,
    T&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the larger of the two values according to the specified comparator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#max(T, T)">max</A></B>(T&nbsp;a,
    T&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the larger of the two values, according to their natural ordering.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#min(java.util.Comparator, T, T)">min</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator,
    T&nbsp;a,
    T&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the smaller of the two values according to the specified
 comparator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#min(T, T)">min</A></B>(T&nbsp;a,
    T&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the smaller of the two values, according to their natural ordering.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
<A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#naturalOrder()">naturalOrder</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that uses the natural ordering of the values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
<A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#nullGreatestOrder()">nullGreatestOrder</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that uses the natural ordering of the values, but also
 handles null values, treating them as greater than all other values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#nullGreatestOrder(java.util.Comparator)">nullGreatestOrder</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;T&gt;&nbsp;comparator)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that treats <code>null</code> as greater than all other
 values and uses the given comparator to compare non-null values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
<A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#nullLeastOrder()">nullLeastOrder</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that uses the natural ordering of the values, but also
 handles null values, treating them as less than all other values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#nullLeastOrder(java.util.Comparator)">nullLeastOrder</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;T&gt;&nbsp;comparator)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that treats <code>null</code> as less than all other
 values and uses <code>comparator</code> to compare non-null values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Comparators.html#toStringOrder()">toStringOrder</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a comparator that compares objects by the natural ordering of their
 string representations as returned by <code>toString()</code>.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="STRING_FORM_ORDER"><!-- --></A><H3>
STRING_FORM_ORDER</H3>
<PRE>
public static final <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&gt; <B>STRING_FORM_ORDER</B></PRE>
<DL>
<DD>A comparator that compares objects by the natural ordering of their string
 representations as returned by <code>toString()</code>. It does not support null
 values.

 <p>TODO: Deprecate this in favor of <A HREF="../../../../com/google/common/collect/Comparators.html#toStringOrder()"><CODE>toStringOrder()</CODE></A>.
<P>
<DL>
</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="naturalOrder()"><!-- --></A><H3>
naturalOrder</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>naturalOrder</B>()</PRE>
<DL>
<DD>Returns a comparator that uses the natural ordering of the values. The
 comparator throws a <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang"><CODE>NullPointerException</CODE></A> when passed a null
 parameter.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="nullLeastOrder(java.util.Comparator)"><!-- --></A><H3>
nullLeastOrder</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>nullLeastOrder</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;T&gt;&nbsp;comparator)</PRE>
<DL>
<DD>Returns a comparator that treats <code>null</code> as less than all other
 values and uses <code>comparator</code> to compare non-null values.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="nullLeastOrder()"><!-- --></A><H3>
nullLeastOrder</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>nullLeastOrder</B>()</PRE>
<DL>
<DD>Returns a comparator that uses the natural ordering of the values, but also
 handles null values, treating them as less than all other values.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="nullGreatestOrder(java.util.Comparator)"><!-- --></A><H3>
nullGreatestOrder</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>nullGreatestOrder</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;T&gt;&nbsp;comparator)</PRE>
<DL>
<DD>Returns a comparator that treats <code>null</code> as greater than all other
 values and uses the given comparator to compare non-null values.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="nullGreatestOrder()"><!-- --></A><H3>
nullGreatestOrder</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>nullGreatestOrder</B>()</PRE>
<DL>
<DD>Returns a comparator that uses the natural ordering of the values, but also
 handles null values, treating them as greater than all other values.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="compound(java.util.Comparator, java.util.Comparator)"><!-- --></A><H3>
compound</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>compound</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second)</PRE>
<DL>
<DD>Returns a comparator which tries two comparators in order until a non-zero
 result is found, returning that result, and returning zero only if both
 comparators return zero.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first comparator to invoke<DD><CODE>second</CODE> - the second comparator to invoke<DT><B>See Also:</B><DD><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.lang.Iterable)"><CODE>compound(Iterable)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compound(java.util.Comparator, java.util.Comparator, java.util.Comparator)"><!-- --></A><H3>
compound</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>compound</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third)</PRE>
<DL>
<DD>Returns a comparator which tries three comparators in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first comparator to invoke<DD><CODE>second</CODE> - the second comparator to invoke<DD><CODE>third</CODE> - the third comparator to invoke<DT><B>See Also:</B><DD><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.lang.Iterable)"><CODE>compound(Iterable)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compound(java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator)"><!-- --></A><H3>
compound</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>compound</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;forth)</PRE>
<DL>
<DD>Returns a comparator which tries four comparators in order until a non-zero
 result is found, returning that result, and returning zero only if all
 comparators return zero.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first comparator to invoke<DD><CODE>second</CODE> - the second comparator to invoke<DD><CODE>third</CODE> - the third comparator to invoke<DD><CODE>forth</CODE> - the fourth comparator to invoke<DT><B>See Also:</B><DD><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.lang.Iterable)"><CODE>compound(Iterable)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compound(java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator, java.util.Comparator...)"><!-- --></A><H3>
compound</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>compound</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;first,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;second,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;third,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;forth,
                                       <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;...&nbsp;rest)</PRE>
<DL>
<DD>Returns a comparator which tries each given comparator in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.

 <p>Subsequent changes to the <code>rest</code> array do not affect the behavior
 of the returned comparator.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first comparator to invoke<DD><CODE>second</CODE> - the second comparator to invoke<DD><CODE>third</CODE> - the third comparator to invoke<DD><CODE>forth</CODE> - the fourth comparator to invoke<DD><CODE>rest</CODE> - additional comparators to invoke as necessary<DT><B>See Also:</B><DD><A HREF="../../../../com/google/common/collect/Comparators.html#compound(java.lang.Iterable)"><CODE>compound(Iterable)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compound(java.lang.Iterable)"><!-- --></A><H3>
compound</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>compound</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&gt;&nbsp;comparators)</PRE>
<DL>
<DD>Returns a comparator which tries each given comparator in order until a
 non-zero result is found, returning that result, and returning zero only if
 all comparators return zero.

 <p>The returned comparator is a "view" of the specified <code>Iterable</code>
 instance; changes to the iterable will be reflected in the behavior of the
 returned comparator.

 <p><b>Warning:</b> Supplying an argument with undefined iteration order,
 such as a <A HREF="http://java.sun.com/javase/6/docs/api/java/util/HashSet.html" title="class or interface in java.util"><CODE>HashSet</CODE></A>, will produce non-deterministic
 results.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>comparators</CODE> - the comparators to try in order</DL>
</DD>
</DL>
<HR>

<A NAME="fromFunction(com.google.common.base.Function)"><!-- --></A><H3>
fromFunction</H3>
<PRE>
public static &lt;F,T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;F&gt; <B>fromFunction</B>(<A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;F,T&gt;&nbsp;function)</PRE>
<DL>
<DD>Creates a comparator that compares any two items by applying a function to
 each of them and using the natural ordering of the results.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>function</CODE> - the function returning the value to compare. The function
     should never return <code>null</code>.
<DT><B>Returns:</B><DD>the generated comparator</DL>
</DD>
</DL>
<HR>

<A NAME="fromFunction(com.google.common.base.Function, java.util.Comparator)"><!-- --></A><H3>
fromFunction</H3>
<PRE>
public static &lt;F,T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;F&gt; <B>fromFunction</B>(<A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;F,T&gt;&nbsp;function,
                                             <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator)</PRE>
<DL>
<DD>Creates a comparator that compares any two items by applying a function to
 each of them and using the supplied comparator to compare the results.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>function</CODE> - the function returning the value to compare<DD><CODE>comparator</CODE> - the comparator that receives the function output
<DT><B>Returns:</B><DD>the generated comparator</DL>
</DD>
</DL>
<HR>

<A NAME="toStringOrder()"><!-- --></A><H3>
toStringOrder</H3>
<PRE>
public static final &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>toStringOrder</B>()</PRE>
<DL>
<DD>Returns a comparator that compares objects by the natural ordering of their
 string representations as returned by <code>toString()</code>. It does not
 support null values.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="min(java.lang.Comparable,java.lang.Comparable)"><!-- --></A><A NAME="min(T, T)"><!-- --></A><H3>
min</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; T <B>min</B>(T&nbsp;a,
                                           T&nbsp;b)</PRE>
<DL>
<DD>Returns the smaller of the two values, according to their natural ordering.
 If the values are equal, the first is returned.

 <p>To handle more than two values, call
 <A HREF="../../../../com/google/common/collect/Ordering.html#min(E, E, E, E...)"><CODE>Ordering.min(Object, Object, Object, Object...)</CODE></A> or
 <A HREF="../../../../com/google/common/collect/Ordering.html#min(java.lang.Iterable)"><CODE>Ordering.min(Iterable)</CODE></A> on the <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A> returned by
 <A HREF="../../../../com/google/common/collect/Ordering.html#natural()"><CODE>Ordering.natural()</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - non-null value to compare, returned if less than or equal to b.<DD><CODE>b</CODE> - non-null value to compare.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/ClassCastException.html" title="class or interface in java.lang">ClassCastException</A></CODE> - if the parameters are not mutually comparable
         (for example, a string and an integer).</DL>
</DD>
</DL>
<HR>

<A NAME="max(java.lang.Comparable,java.lang.Comparable)"><!-- --></A><A NAME="max(T, T)"><!-- --></A><H3>
max</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; T <B>max</B>(T&nbsp;a,
                                           T&nbsp;b)</PRE>
<DL>
<DD>Returns the larger of the two values, according to their natural ordering.
 If the values are equal, the first is returned.

 <p>To handle more than two values, call
 <A HREF="../../../../com/google/common/collect/Ordering.html#max(E, E, E, E...)"><CODE>Ordering.max(Object, Object, Object, Object...)</CODE></A> or
 <A HREF="../../../../com/google/common/collect/Ordering.html#max(java.lang.Iterable)"><CODE>Ordering.max(Iterable)</CODE></A> on the <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A> returned by
 <A HREF="../../../../com/google/common/collect/Ordering.html#natural()"><CODE>Ordering.natural()</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - non-null value to compare, returned if greater than or equal to b.<DD><CODE>b</CODE> - non-null value to compare.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/ClassCastException.html" title="class or interface in java.lang">ClassCastException</A></CODE> - if the parameters are not mutually comparable
         (for example, a string and an integer).</DL>
</DD>
</DL>
<HR>

<A NAME="min(java.util.Comparator,java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="min(java.util.Comparator, T, T)"><!-- --></A><H3>
min</H3>
<PRE>
public static &lt;T&gt; T <B>min</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator,
                        <FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                        T&nbsp;a,
                        <FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                        T&nbsp;b)</PRE>
<DL>
<DD>Returns the smaller of the two values according to the specified
 comparator. If the values are equal, the first is returned. Null values
 are allowed if the comparator supports them.

 <p>To handle more than two values, call
 <A HREF="../../../../com/google/common/collect/Ordering.html#min(E, E, E, E...)"><CODE>Ordering.min(Object, Object, Object, Object...)</CODE></A> or
 <A HREF="../../../../com/google/common/collect/Ordering.html#min(java.lang.Iterable)"><CODE>Ordering.min(Iterable)</CODE></A> on the <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A> returned by
 <A HREF="../../../../com/google/common/collect/Ordering.html#forComparator(java.util.Comparator)"><CODE>Ordering.forComparator(Comparator)</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>comparator</CODE> - comparator that compares the two values<DD><CODE>a</CODE> - value to compare, returned if less than or equal to b<DD><CODE>b</CODE> - value to compare</DL>
</DD>
</DL>
<HR>

<A NAME="max(java.util.Comparator,java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="max(java.util.Comparator, T, T)"><!-- --></A><H3>
max</H3>
<PRE>
public static &lt;T&gt; T <B>max</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super T&gt;&nbsp;comparator,
                        <FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                        T&nbsp;a,
                        <FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                        T&nbsp;b)</PRE>
<DL>
<DD>Returns the larger of the two values according to the specified comparator.
 If the values are equal, the first is returned. Null values are allowed if
 the comparator supports them.

 <p>To handle more than two values, call
 <A HREF="../../../../com/google/common/collect/Ordering.html#max(E, E, E, E...)"><CODE>Ordering.max(Object, Object, Object, Object...)</CODE></A> or
 <A HREF="../../../../com/google/common/collect/Ordering.html#max(java.lang.Iterable)"><CODE>Ordering.max(Iterable)</CODE></A> on the <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A> returned by
 <A HREF="../../../../com/google/common/collect/Ordering.html#forComparator(java.util.Comparator)"><CODE>Ordering.forComparator(Comparator)</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>comparator</CODE> - comparator that compares the two values<DD><CODE>a</CODE> - value to compare, returned if greater than or equal to b<DD><CODE>b</CODE> - value to compare</DL>
</DD>
</DL>
<HR>

<A NAME="givenOrder(java.util.List)"><!-- --></A><H3>
givenOrder</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>givenOrder</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;? extends T&gt;&nbsp;valuesInOrder)</PRE>
<DL>
<DD>Returns a comparator that compares objects according to the order in
 which they appear in the given list. Only objects present in the list
 (according to <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A>) may be compared. This comparator
 imposes a "partial ordering" over the type <code>T</code>. Subsequent changes
 to the <code>valuesInOrder</code> list will have no effect on the returned
 comparator. Null values in the list are supported.

 <p>The returned comparator throws an <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/ClassCastException.html" title="class or interface in java.lang"><CODE>ClassCastException</CODE></A> when it
 receives an input parameter that isn't in <code>valuesInOrder</code>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>valuesInOrder</CODE> - the values that the returned comparator will be able
     to compare, in the order the comparator should follow
<DT><B>Returns:</B><DD>the comparator described above
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if <code>valuesInOrder</code> contains any
     non-consecutive duplicate values (according to <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A>)</DL>
</DD>
</DL>
<HR>

<A NAME="givenOrder(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="givenOrder(T, T...)"><!-- --></A><H3>
givenOrder</H3>
<PRE>
public static &lt;T&gt; <A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering</A>&lt;T&gt; <B>givenOrder</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                                         T&nbsp;leastValue,
                                         T...&nbsp;remainingValuesInOrder)</PRE>
<DL>
<DD>Returns the comparator that compares objects according to the order in
 which they are given to this method. Only objects present in the argument
 list (according to <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A>) may be compared. This comparator
 imposes a "partial ordering" over the type <code>T</code>. Null values in the
 argument list are supported.

 <p>The returned comparator throws a <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/ClassCastException.html" title="class or interface in java.lang"><CODE>ClassCastException</CODE></A> when it
 receives an input parameter that isn't equal to <code>leastValue</code>
 or in <code>remainingValuesInOrder</code>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>leastValue</CODE> - the value which the returned comparator should consider
     the "least" of all values<DD><CODE>remainingValuesInOrder</CODE> - the rest of the values that the returned
     comparator will be able to compare, in the order the comparator should
     follow
<DT><B>Returns:</B><DD>the comparator described above
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if any non-consecutive duplicate values
     (according to <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A>) are present among the method
     arguments</DL>
</DD>
</DL>
<HR>

<A NAME="compare(byte, byte)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(byte&nbsp;a,
                          byte&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>byte</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Byte.valueOf(a).compareTo(Byte.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>byte</code> to compare<DD><CODE>b</CODE> - the second <code>byte</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.</DL>
</DD>
</DL>
<HR>

<A NAME="compare(char, char)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(char&nbsp;a,
                          char&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>char</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Character.valueOf(a).compareTo(Character.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>char</code> to compare<DD><CODE>b</CODE> - the second <code>char</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.</DL>
</DD>
</DL>
<HR>

<A NAME="compare(short, short)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(short&nbsp;a,
                          short&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>short</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Short.valueOf(a).compareTo(Short.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>short</code> to compare<DD><CODE>b</CODE> - the second <code>short</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.</DL>
</DD>
</DL>
<HR>

<A NAME="compare(int, int)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(int&nbsp;a,
                          int&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>int</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Integer.valueOf(a).compareTo(Integer.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>int</code> to compare<DD><CODE>b</CODE> - the second <code>int</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.</DL>
</DD>
</DL>
<HR>

<A NAME="compare(long, long)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(long&nbsp;a,
                          long&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>long</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Long.valueOf(a).compareTo(Long.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>long</code> to compare<DD><CODE>b</CODE> - the second <code>long</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.</DL>
</DD>
</DL>
<HR>

<A NAME="compare(double, double)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(double&nbsp;a,
                          double&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>double</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Double.valueOf(a).compareTo(Double.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>double</code> to compare<DD><CODE>b</CODE> - the second <code>double</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Double.html#compare(double, double)" title="class or interface in java.lang"><CODE>Double.compare(double, double)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compare(float, float)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(float&nbsp;a,
                          float&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>float</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Float.valueOf(a).compareTo(Float.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>float</code> to compare<DD><CODE>b</CODE> - the second <code>float</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is less than <code>b</code>; a positive
     value if <code>a</code> is greater than <code>b</code>; otherwise zero.<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Float.html#compare(float, float)" title="class or interface in java.lang"><CODE>Float.compare(float, float)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="compare(boolean, boolean)"><!-- --></A><H3>
compare</H3>
<PRE>
public static int <B>compare</B>(boolean&nbsp;a,
                          boolean&nbsp;b)</PRE>
<DL>
<DD>Compares the two specified <code>boolean</code> values. The sign of the value
 returned is the same as that of the value that would be returned by the
 call:

 <pre>  Boolean.valueOf(a).compareTo(Boolean.valueOf(b))</pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>a</CODE> - the first <code>boolean</code> to compare<DD><CODE>b</CODE> - the second <code>boolean</code> to compare
<DT><B>Returns:</B><DD>a negative value if <code>a</code> is false and <code>b</code> is true; a
     positive value if <code>a</code> is true and <code>b</code> is false; otherwise
     zero.</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/Collections2.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/ConcurrentMultiset.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/Comparators.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Comparators.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
